function renderTemplate(canvas, pool, config, uploads) {
    // 这里存放的images是图片资源(不包括上传的图片)
    var images = BI.ImageData;
    BI.each(JSON.parse(uploads), function (id, img) {
        images[BI.Func.getCompleteImageUrl(id)] = img;
    });
    BI.pool = JSON.parse(pool);
    BI.designConfigure = JSON.parse(config);
    BI.designData = BI.deepExtend({},
        BI.deepClone(BI.Constants.getConstant('bi.constant.design.template.conf')),
        BI.designConfigure, {
            isEdit: false
        }
    );
    BI.widgetData = BI.extend(BI.pool.dataPool.widget, BI.pool.dataPool.content);

    var ctx = canvas.getContext("2d");
    ctx.font = "12px sans-serif";
    window.ctx = ctx;
    window.canvas = canvas;
    window.devicePixelRatio = 1;

    var renderBounds = getRenderBounds();
    canvas.width = renderBounds.width;
    canvas.height = renderBounds.height;
    var root = (window.root = BI.createWidget({
        rootImage: true,
        type: "bi.vertical",
        scrolly: false,
        items: [
            {
                el: {
                    type: "bi.static",
                    width: renderBounds.width,
                    height: renderBounds.height,
                    innerWidth: renderBounds.innerWidth,
                    innerHeight: renderBounds.innerHeight
                }
            }
        ]
    }));
    BI.Element.mountImage(root, {
        canvas: canvas,
        ctx: ctx,
        imageFetcher: function (url) {
            url = url || "";
            return images[url] || images[BI.replaceAll(url, '.*/[12]x/(.*)', function (str1, str2) {
                return str2;
            })] || {};
        }
    });
}

function getRenderBounds() {
    var width, height, innerWidth, innerHeight;
    if (BI.pool.confPool && BI.pool.confPool.widgetId) {
        var bounds = BI.designData.widgets[BI.pool.confPool.widgetId].bounds;
        width = Math.ceil(bounds.width);
        height = Math.ceil(bounds.height);
        innerWidth = width;
        innerHeight = height;
    } else {
        var layoutRatio = BI.designData.layoutRatio || {};
        var freeLayoutRatio = BI.designData.freeLayoutRatio || {};
        width = 1920;
        height = 1080 * Math.max(layoutRatio.y || 1, freeLayoutRatio.y || 1);
        innerWidth = 1920;
        innerHeight = 1080;
    }

    return {
        width: width,
        height: height,
        innerWidth: innerWidth,
        innerHeight: innerHeight
    }
}

function getComputedWidgets(pool, config) {
    BI.pool = JSON.parse(pool);
    BI.designConfigure = JSON.parse(config);
    BI.designData = BI.deepExtend(
        {},
        BI.deepClone(BI.Constants.getConstant('bi.constant.design.template.conf')),
        BI.designConfigure
    );
    BI.designModel = BI.designData;
    var service = BI.Services.getService("bi.service.static.calculate");
    return JSON.stringify(service.getWidgetMap(BI.designConfigure));
}

function getAllWidgetNam() {
    var result = {};
    BI.Utils.getWidgetNameById(BI.Utils.getAllWidgetIds(), function (names) {
        result = names;
    });

    return JSON.stringify(result);
}

function getContentWidgets(pool, config) {
    BI.pool = JSON.parse(pool);
    BI.designConfigure = JSON.parse(config);
    BI.designData = BI.deepExtend(
        {},
        BI.deepClone(BI.Constants.getConstant('bi.constant.design.template.conf')),
        BI.designConfigure
    );
    BI.designModel = BI.designData;
    var service = BI.Services.getService("bi.service.static.calculate");
    return JSON.stringify(service.getContentWidgetTargets(BI.designConfigure));
}

var imageKeys = ['id', 'imageId', 'src'];
var imagePrefix = ['MapCache', 'query', 'default', 'session', 'holder'];

function getImageIds(config, result) {
    result = result || [];
    BI.each(config, function (k, v) {
        if (typeof v === "string" && BI.contains(imageKeys, k) && (
            BI.some(imagePrefix, function (id, prefix) {
                return v.indexOf(prefix) === 0;
            })
        )) {
            result.push(v);
        }

        if (typeof v === "object") {
            getImageIds(v, result);
        }
    });
    return result;
}

function getUploadImageIds(config) {
    config = JSON.parse(config);
    return JSON.stringify(getImageIds(config));
}